{-# LANGUAGE ExistentialQuantification, EmptyDataDecls #-}

--- Slightly more complicated phantom/singleton type example
--- Natural numbers and Length-indexed lists

module NList (Z, S, List, nil, cons, sHead, sTail, LT, z, s, sLookup) where

-- natural numbers 
data Z 
data S x

newtype List n b = L [b]

instance Show b => Show (List n b) where
	 show (L l) = show l

nil :: List Z a
nil = (L [])

cons :: b -> List n b -> List (S n) b
cons hd (L tl) = L (hd : tl)

sHead :: List (S n) b -> b
sHead (L l) = head l

sTail :: List (S n) b -> List n b
sTail (L l) = L (tail l)

-- Bounded natural numbers. I.e. a number m that comes with
--    an assertion that it is less than some other number n
data LT n = I Int

instance Show (LT n) where
  show (I i) = show i

z :: LT (S m) 
z = I 0

s :: LT n -> LT (S n)
s (I x) = I (x + 1)

-- only lookup at a position less than the length of the list
sLookup :: LT n -> List n a -> a
sLookup (I 0)  (L (x : xs)) = x
sLookup (I lt) (L (x : xs)) = sLookup (I (lt - 1)) (L xs)








