module SListTest where

import SList (List, Safe, Unsafe, cons, nil, testnull, forget,
              sHead, sTail, sElem, sLast, sInit, sMap, sFilter )


data Entry = Entry { name   :: String, 
                     -- Store at least one number per person, first one is default
                     number :: List Safe Int } deriving (Show)

getNumber :: Entry -> Int
getNumber e = sHead (number e)

addDefault :: Int -> Entry -> Entry
addDefault i e = 
  if not (sElem i l) 
  then e { number = cons i l }
  else e 
    where l = number e 

addOther  :: Int -> Entry -> Entry
addOther i e = 
  if not (sElem i l)
  then e { number = cons (sHead l) (cons i (sTail l)) }
  else e
    where l = number e

rotate :: Entry -> Entry
rotate e = 
	 e { number = cons (sLast l) (sInit l) }
    where l = number e


stephanie = Entry { name = "Stephanie", number = cons 1 (cons 2 nil) }

benjamin = Entry { name = "Benjamin", number = nil }