module Interp1 where

data Exp = 
    Var Int 
  | Lit Int
  | Lam Exp 
  | App Exp Exp deriving (Show)

data Value = 
    Const Int
  | Clos Env Exp deriving (Show)

type Env = [ Value ] 

look :: Int -> Env -> Value
look x e = e !! x

extend :: Value -> Env -> Env
extend v e = (v : e) 

interp :: Env -> Exp -> Value
interp e (Var x)   = look x e
interp e (Lit i)   = Const i
interp e (Lam t) = Clos e t
interp e (App t1 t2) = 
  case interp e t1 of
    (Clos e' t) -> interp (extend (interp e t2) e') t
    _  -> error "Type error"


t0 = interp [] (App (Lam (Var 0)) (Lit 2))

t1 = interp [] (Var 1)

t2 = interp [] (App (Lit 2) (Lit 3))
